<?php
/*****************************************************************
* SMF Media Gallery												 *
* Version 2.0													 *
*  SMF-Media.com												 *
******************************************************************
* MGalleryItem.php												 *
******************************************************************
* Users of this software are bound by the terms of the           *
* SMG license. You can view it in the license_smg.txt file,      *
* or online at http://smf-media.com/smg/license.php              *
*                                                                *
* Support and updates for this software can be found at          *
* http://smf-media.com											 *
*****************************************************************/

if (file_exists(dirname(__FILE__).'/SSI.php'))
	require_once(dirname(__FILE__).'/SSI.php');
else
	die('SSI.php wasn\'t found');

global $settings, $mgalFunc, $context, $sourcedir;

require_once($sourcedir . '/Subs-MGallery.php');

loadMGal_Settings();

// Banned?
is_not_banned_mgal();

if (!isset($_REQUEST['id']))
	die('Hacking attempt...');

// Get the file's data
$id = (int) $_REQUEST['id'];
$type = isset($_REQUEST['thumb']) ? 'thumb' : (isset($_REQUEST['preview']) ? 'preview' : 'main');

if (!mGalAllowedTo('access'))
{
	$path = $settings['theme_dir'] . '/images/mgallery/denied.png';
	$filename = 'denied.png';
}
else
	list($path, $filename) = getMediaFilePath($id, $type);

if (!$path)
{
	header('HTTP/1.0 404 Not Found');
	die('Error! File not found');
}

$media = new mgal_media_handler;
$media->init($path);
$mime = $media->getMimeType();
$media->close();

if (function_exists('ob_get_level'))
	while (@ob_get_level() > 0)
		@ob_end_clean();
else
{
	@ob_end_clean();
	@ob_end_clean();
	@ob_end_clean();
}

// Send it
header('Pragma: ');
if (!$context['browser']['is_gecko'])
	header('Content-Transfer-Encoding: binary');
header('Expires: ' . gmdate('D, d M Y H:i:s', time() + 525600 * 60) . ' GMT');
header('Last-Modified: ' . gmdate('D, d M Y H:i:s', filemtime($path)) . ' GMT');
header('Accept-Ranges: bytes');
header('Content-Length: ' . filesize($path));
header('Content-Encoding: none');
header('Content-Type: '.$mime);
header('Content-Disposition: inline; filename='.$filename);

// If the file is over 1.5MB, readfile() may have some issues.
if (filesize($path) > 1572864 || @readfile($path) == null)
{
	if ($file = fopen($path, 'rb'))
	{
		while (!feof($file))
		{
			echo @fread($file, 8192);
			flush();
		}
		@fclose($file);
	}
	else
		die('Something went wrong...');
}

// Nothing more to come
die;

?>